define("wagby/Select", [
  "dojo/_base/declare",
  "dojo/string",
  "dojo/dom-class",
  "dojo/dom-style",
  "dojo/on",
  "dojo/query",
  "dijit/form/Select"
], function(declare, string, domClass, domStyle, on, query, Select){
  return declare("wagby.Select", [Select], {
    style: "",

    postCreate: function(){
      this.inherited(arguments);
      this.setStyle();
      this.setErrorStyle();
      on(this.focusNode, "focus", function() {
        setScrollPosition(this.id);
      });
    },

    setErrorStyle: function() {
      if (!this.inputError) {
        return;
      }
      query("td.dijitButtonContents", this.focusNode).forEach(function(node) {
        domClass.add(node, "errorfield");
      });
    },

    setStyle: function() {
      if (this.style === "") {
        return;
      }
      // デフォルトの背景色設定をクリアする
      if (this.style.indexOf("background-color") > 0) {
        domStyle.set(this.valueNode.parentNode, "background", "none");
      }
      var styles = this.style.split(";");
      for (var i=0; i<styles.length; i++) {
        if (styles[i] === "") {
          continue;
        }
        var styleAttribute = styles[i].split(":");
        var styleName = string.trim(styleAttribute[0]);
        var styleValue = string.trim(styleAttribute[1]);
        if (styleName === "" || styleValue === "") {
          continue;
        }
        domStyle.set(this.valueNode.parentNode, styleName, styleValue);
      }
    },

  });
});
